/******************************************************************************/
/*                                                                            */
/*                                                         FILE: cgiparam.cpp */
/*                                                                            */
/*     Decodes the variables of a HTTP POST request                           */
/*     ============================================                           */
/*                                                                            */
/*     V1.00   19-DEC-2014     Te                                             */
/*                                                                            */
/******************************************************************************/
#include <cstdlib>
#include <cstdio>
#include <iostream>
#include <map>

using namespace std ;

enum STATE { TEXT, ESCAPE1, ESCAPE2 } ;

/******************************************/
 multimap<string,string> GetCGIParameters()
/******************************************/

{
   multimap<string,string> result ;

   const char *length = getenv( "CONTENT_LENGTH" ) ;

   if( length != NULL )
   {
      STATE  state = TEXT ;
      string value ;
      string key ;
      char   chr ;
      int    ch ;

      string *ps = &key ;
      for( int len = atoi(length); (len > 0) && ((ch = cin.get()) != EOF); --len )
      {
         switch( ch )
         {
          case '+': *ps  += ' ' ;
                    state = TEXT ;
                    break ;

          case '%': state = ESCAPE1 ;
                    break ;

          case '&': if( key.size() > 0 )
                       result.insert( pair<string,string>(key,value) ) ;

                    key.clear() ;
                    value.clear() ;
                    ps    = &key ;

                    state = TEXT ;
                    break ;

          case '=': ps    = &value ;
                    state = TEXT ;
                    break ;

          default:  switch( state )
                    {
                     case TEXT:    *ps += (char)ch ;
                                   break ;

                     case ESCAPE1: state = ESCAPE2 ;
                                   if( (ch >= '0') && (ch <= '9') )
                                      chr = (ch - '0') ;
                                   else if( (ch >= 'A') && (ch <= 'F') )
                                      chr = (ch - 'A') + 10 ;
                                   else if( (ch >= 'a') && (ch <= 'f') )
                                      chr = (ch - 'a') + 10 ;
                                   else
                                      state = TEXT ;
                                   break ;

                     case ESCAPE2: chr <<= 4 ;
                                   if( (ch >= '0') && (ch <= '9') )
                                   {
                                      chr |= (ch - '0') ;
                                      *ps += chr ;
                                   }
                                   else if( (ch >= 'A') && (ch <= 'F') )
                                   {
                                      chr |= (ch - 'A') + 10 ;
                                      *ps += chr ;
                                   }
                                   else if( (ch >= 'a') && (ch <= 'f') )
                                   {
                                      chr |= (ch - 'a') + 10 ;
                                      *ps += chr ;
                                   }
                                   state = TEXT ;
                                   break ;
                    }
                    break ;
         }
      }

      if( key.size() > 0 )
         result.insert( pair<string,string>(key,value) ) ;
   }

   return result ;
}
